Package org.apache.groovy.contracts.ast.visitor

# Class DomainModelInjectionVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.apache.groovy.contracts.ast.visitor.BaseVisitor
org.apache.groovy.contracts.ast.visitor.DomainModelInjectionVisitor

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class DomainModelInjectionVisitor extends BaseVisitor
Visits the given `ClassNode` and injects the current `Contract` into the given AST nodes.

See Also:
  - `Contract`

- ## Field Summary

  ### Fields inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `GCONTRACTS_ENABLED_VAR, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DomainModelInjectionVisitor(SourceUnit sourceUnit, ReaderSource source, ProcessingContextInformation pci)`
  Creates a visitor that materializes the accumulated contract domain model back into AST nodes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `injectClassInvariant(ClassNode type, ClassInvariant classInvariant)`
  Generates AST support for the supplied class invariant.
  `void`
  `injectPostcondition(MethodNode method, Postcondition postcondition)`
  Generates AST support for the supplied postcondition.
  `void`
  `injectPrecondition(MethodNode method, Precondition precondition)`
  Generates AST support for the supplied precondition.
  `void`
  `visitClass(ClassNode type)`
  Injects all contract elements currently present in the domain model into the supplied class.

  ### Methods inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitchExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Constructor Details

  - ### DomainModelInjectionVisitor

    public DomainModelInjectionVisitor(SourceUnit sourceUnit, ReaderSource source, ProcessingContextInformation pci)
    Creates a visitor that materializes the accumulated contract domain model back into AST nodes.
    Parameters:
      `sourceUnit` - the source unit currently being transformed
      `source` - the reader source backing the source unit
      `pci` - per-class processing context shared across the contracts pipeline

- ## Method Details

  - ### visitClass

    public void visitClass(ClassNode type)
    Injects all contract elements currently present in the domain model into the supplied class.
    Specified by:
      `visitClass` in interface `GroovyClassVisitor`
    Overrides:
      `visitClass` in class `ClassCodeVisitorSupport`
    Parameters:
      `type` - the class to update

  - ### injectClassInvariant

    public void injectClassInvariant(ClassNode type, ClassInvariant classInvariant)
    Generates AST support for the supplied class invariant.
    Parameters:
      `type` - the class that should receive the invariant
      `classInvariant` - the invariant to inject

  - ### injectPrecondition

    public void injectPrecondition(MethodNode method, Precondition precondition)
    Generates AST support for the supplied precondition.
    Parameters:
      `method` - the method that should receive the precondition
      `precondition` - the precondition to inject

  - ### injectPostcondition

    public void injectPostcondition(MethodNode method, Postcondition postcondition)
    Generates AST support for the supplied postcondition.
    Parameters:
      `method` - the method that should receive the postcondition
      `postcondition` - the postcondition to inject